package br.mp.mprj.portal.portlet.caderno;

//import br.mp.mprj.portal.portlet.doerj.job.MigracaoPDFAntigosJobUtil;
//import br.mp.mprj.portal.portlet.doerj.util.DoerjUtil;

import br.mp.mprj.portal.portlet.caderno.rest.RestServices;
import br.mp.mprj.portal.portlet.caderno.service.GeraCaderno;
import br.mp.mprj.portal.portlet.caderno.util.CadernoUtil;
import br.mp.mprj.portal.portlet.caderno.util.Estilos;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSONFactoryUtil;
import com.liferay.portal.kernel.servlet.SessionErrors;
import com.liferay.portal.kernel.upload.UploadPortletRequest;
import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.portal.kernel.util.WebKeys;
import com.liferay.portal.theme.ThemeDisplay;
import com.liferay.portal.util.PortalUtil;
import com.liferay.portlet.PortletURLFactoryUtil;
import com.liferay.util.bridges.mvc.MVCPortlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.HashMap;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletContext;
import javax.portlet.PortletException;
import javax.portlet.PortletRequest;
import javax.portlet.PortletURL;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.xml.bind.JAXBException;

import org.apache.log4j.Logger;
import org.docx4j.XmlUtils;
import org.docx4j.model.datastorage.migration.VariablePrepare;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.HeaderPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.json.JSONArray;
import org.json.JSONObject;



public class CadernoPortlet extends MVCPortlet{
	
	final static Logger logger = Logger.getLogger(CadernoPortlet.class);

	public void serveResource(ResourceRequest resourceRequest,
			ResourceResponse resourceResponse) throws IOException,
			PortletException {
		ThemeDisplay themeDisplay = (ThemeDisplay) resourceRequest.getAttribute(WebKeys.THEME_DISPLAY);
		UploadPortletRequest uploadRequest=PortalUtil.getUploadPortletRequest(resourceRequest);
		String valor = ParamUtil.getString(resourceRequest, "parameter");
		String cmd = ParamUtil.getString(resourceRequest, "caderno");
		String dataDivulgacao = ParamUtil.getString(uploadRequest, "dataP");
		String situacao = ParamUtil.getString(uploadRequest, "situacao");


			//System.out.println(valor);
			
			com.liferay.portal.kernel.json.JSONObject jsonResponse = JSONFactoryUtil.createJSONObject();
			
			if (cmd.equals("geraCaderno")){
				
				try {
					geraCaderno(resourceRequest,resourceResponse,dataDivulgacao,situacao);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}else{
				//System.out.println(valor);
				try {
					jsonResponse.put("result", CadernoUtil.getDatasCadastradas());
					
				} catch (SystemException e) {
					// TODO Auto-generated catch block
					logger.error("Erro requisicao AJAX",e);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					logger.error("Erro validar horários AJAX",e);
				}
				// Writing the result in resourceResponse writer.
				PrintWriter writer = resourceResponse.getWriter();
				writer.println(jsonResponse);
			// Creating a JSON object which will contain the sum.
			}
	}
	
	public void geraCaderno(ResourceRequest resourceRequest,
			ResourceResponse resourceResponse,String dataDivulgacao,String idStatus)throws Exception {

		UploadPortletRequest uploadRequest=PortalUtil.getUploadPortletRequest(resourceRequest);
		ThemeDisplay themeDisplay = (ThemeDisplay) uploadRequest.getAttribute(WebKeys.THEME_DISPLAY);
		
		JSONArray listaConteudos = new JSONArray();
		RestServices rest = new RestServices();
		String dataDivulgacaoRest = dataDivulgacao.replace("/", "");
		listaConteudos = rest.getRest(dataDivulgacaoRest,idStatus);
		
		
		if(!mensagensDeErro(listaConteudos, dataDivulgacao, resourceRequest)){
		GeraCaderno caderno = new GeraCaderno();
		
		caderno.processaCaderno(resourceRequest, resourceResponse,listaConteudos,dataDivulgacao);
		}else{
		
			com.liferay.portal.kernel.json.JSONObject jsonResponse = JSONFactoryUtil.createJSONObject();
			jsonResponse.put("erroDataNula", true);
			PrintWriter writer = resourceResponse.getWriter();
			writer.println(jsonResponse);
			
		}
		
		String portletName = (String) resourceRequest.getAttribute(WebKeys.PORTLET_ID);
		PortletURL redirectURL = PortletURLFactoryUtil.create(PortalUtil.getHttpServletRequest(resourceRequest), portletName, themeDisplay.getLayout().getPlid(),
				PortletRequest.RENDER_PHASE);
		redirectURL.setParameter("jspPage", "/jsp/admin/view-admin.jsp");
		//resourceResponse.sendRedirect(redirectURL.toString());
		
		
	}
	
	
	
	protected Boolean mensagensDeErro(JSONArray listaConteudos, String dataDivulgacao, ResourceRequest resourceRequest) throws ParseException{
		Boolean contemErro = Boolean.FALSE;
		
		if(listaConteudos.length()==0) {
			contemErro = Boolean.TRUE;
			resourceRequest.setAttribute("erro", true);
			SessionErrors.add(resourceRequest.getPortletSession(), "erroArquivo");
		} else 	if(dataDivulgacao.equals("")) {
			contemErro = Boolean.TRUE;
			resourceRequest.setAttribute("erroVazio", true);
			SessionErrors.add(resourceRequest.getPortletSession(), "erroVazio");
		} 
		return contemErro;
	}
	
}
